#!/usr/bin/perl -w


# config
$config='/etc/fido/uuedec/uuedec.conf';


### Pogramm ################################################### Don't touch ###
use DB_File;

$ver="UUE Decoder v0.55 (c) Sln !";


# parse config #
open(CFG, "< $config") || die "$config: $!\n";

($spooldec,@spoolpkt,@maskpkt,@echo,%file,%set,%archid,%archext,$archdef)=();
$i=0;

while(<CFG>){
$i++;

$spooldec=$1		if /^decoded\s+(\S+)/i;
push @spoolpkt,$1	if /^pkt\s+(\S+)/i;
push @maskpkt,$1	if /^maskpkt\s+(\S+)/i;

$file{log}=$1		if /^log\s+(\S+)/i;
$file{res}=$1		if /^resource\s+(\S+)/i;
$file{rec}=$1		if /^recode\s+(\S+)/i;
$file{dup}=$1		if /^dupe\s+(\S+)/i;
$file{sts}=[$1,$2]	if /^stat\s+(\S+)\s+([abc]{1,3})/i;
$file{bbs}=[$1,$2]	if /^bbsfiles\s+(\S+)\s+(\S+)/i;
$file{diz}=$1		if /^diz\s+(\S+)/i;
$file{tmp}=$1		if /^temp\s+(\S+)/i;

$set{dos}=$1		if /^rendos\s+(\d)/i;
$set{cmp}=$1		if /^rencomp\s+(\d)/i;
$set{code}=$1		if /^rencode\s+(\d)/i;
$set{dupe}=$1		if /^dupename\s+(\d)/i;
$set{del}=$1		if /^delpkt\s+(\d)/i;
$set{keep}=$1		if /^keepuue\s+(\d+)/i;
$set{rec}=$1		if /^bbsrec\s+(\d)/i;
$set{bad}=$1		if /^savebad\s+(\d)/i;
$set{form}=$1		if /^bbsform\s+(.+)/i;
$set{next}=$1		if /^bbsnext\s+(\d+)/i;

$archid{$i}=[$3,$2,$1]	if /^archid\s+(-?\d+)\s+([\dA-F]+)\s+(.+)/i;
$archext{$i}=[$1,$2]	if /^archext\s+(\S+)\s+(.+)/i;
$archdef=$1		if /^archdef\s+(.+)/i;

push @echo,[$1,$2]	if /^echo\s+(\S+)\s+(\S+)/i;


}
close CFG;




die "Check spool for decoded files (not def)\n" unless defined $spooldec;
die "Check spool for incoming pkts (not def)\n" unless @spoolpkt;
die "Check mask for incoming pkts\n"		unless @maskpkt;
die "Check set any param from config\n"		if keys %set !=10;
die "Echo mask not defined\n"			unless @echo;
die "Default archiv not defined\n"		unless $archdef;

uplog("Starting $ver");




# parse archid
foreach(keys %archid){ $archid{$_}[1]=join '',map{chr hex} $archid{$_}[1]=~/../g }


# parse recode file
if(exists $file{rec}){
uplog("Loading recode file");
 open(CODE, "< $file{rec}") || errlog("$file{rec}: $!");
  $in=$out='';
   while(<CODE>){ $in.="\\$1",$out.="\\$2" if /^0+(x[\da-f]+)\s+0+(x[\da-f]+)/i }
 close(CODE);
}


# get pkts
undef %pktbase;
$i=$size=0;
$mask='^('.(join '|', map{esc($_)} @maskpkt).')$';
 foreach $dir (@spoolpkt){
  opendir(DIR, $dir) || errlog("$dir: $!");
  foreach(grep {/$mask/i and -f "$dir/$_"} readdir DIR){ $pktbase{$i}=["$dir/$_", -s "$dir/$_"]; $size+=$pktbase{$i}[1]; $i++ }
  close(DIR);
 }

uplog("Found ".(keys %pktbase)." incoming pkt at $size bytes");



undef %uue;
undef %uuehead;

# load resorce file
if(exists $file{res}){
 uplog("Loading resource file");
 dbmopen(%res, $file{res}, 0660) || errlog("$file{res}: $!");
  foreach(keys %res){
   @_=split /\0/, $res{$_},7;
   @{$uuehead{$_[0]}{$_[1]}}{'time','last','size'}=@_[3..5];
   $uue{$_[0]}{$_[1]}{$_[2]}=$_[6];
  }
 dbmclose(%res);
}



# load dupebase
if(exists $file{dup}){
 uplog("Loading dupe base");
 dbmopen(%dup,$file{dup},0660) || errlog("$file{dup}: $!");
 %dupe=%dup;
 dbmclose(%dup);
}





# parse pkts
foreach $pkt (sort {$a<=>$b} keys %pktbase){
 if(open(PKT, "< $pktbase{$pkt}[0]")){
  binmode(PKT);
  if(pkthead()){ uplog("Scaning: $pktbase{$pkt}[0] ($pktbase{$pkt}[1] bytes, $pkt{fromzone}:$pkt{fromnet}/$pkt{fromnode}.$pkt{frompnt} -> $pkt{tozone}:$pkt{tonet}/$pkt{tonode}.$pkt{topnt})"); msgs() }
           else{ uplog("Bad pkt struct '$pktbase{$pkt}[0]'") }
  close(PKT);
 }else{ uplog("$pktbase{$pkt}[0]: $!") }
}



undef %dec;

foreach $area (sort {$a cmp $b} keys %uue){
foreach $file (sort {lc($a) cmp lc($b)} keys %{$uue{$area}}){

# decoding
if(scalar(keys %{$uue{$area}{$file}}) >= $uuehead{$area}{$file}{last}){
 $dec=unpack("u", join '', map {$uue{$area}{$file}{$_}} sort {$a <=> $b} keys %{$uue{$area}{$file}});
 $size=length $dec;
 uplog("Complete: $file $size bytes, $uuehead{$area}{$file}{last} section(s), area $area)");

 # chk decoded
 if($uuehead{$area}{$file}{size} == -1){
  $dec{ok}{$area}{$file}=[$size,$uuehead{$area}{$file}{last}];
 }else{
   if($uuehead{$area}{$file}{size} == $size){
    $dec{ok}{$area}{$file}=[$size,$uuehead{$area}{$file}{last}];
   }else{
    uplog("Bad decoded $file (expect $uuehead{$area}{$file}{size} bytes, have $size bytes)");
    $dec{bad}{$area}{$file}=[$size,$uuehead{$area}{$file}{size}];
      unless($set{bad}){
      uplog("Delete bad $file");
      delete $uue{$area}{$file};
      next;
    }
   }
 }

 delete $uue{$area}{$file};
 savefile($area,$file,$dec,$size,@{$uuehead{$area}{$file}}{'subj','from'});
}else{
 uplog("Incomplete: $file (expect $uuehead{$area}{$file}{last}, have ".(keys %{$uue{$area}{$file}})." section(s), area $area)");
 $dec{inc}{$area}{$file}=[$uuehead{$area}{$file}{last},scalar(keys %{$uue{$area}{$file}})];
}

}
}




# save statistic
if(exists $file{sts} and %dec){

undef $stat;

# normal
if(exists $dec{ok} and $file{sts}[1]=~/a/i){
$stat.="\nComplete:\n";
foreach $area (sort {$a cmp $b} keys %{$dec{ok}}){
$stat.=">".uc($area)."\n";
foreach $file (sort {lc($a) cmp lc($b)} keys %{$dec{ok}{$area}}){
$stat.=f2s(a2k($file)).s2s($dec{ok}{$area}{$file}[0])."bytes, $dec{ok}{$area}{$file}[1] section(s)\n";
}
}
}


# bad
if(exists $dec{bad} and $file{sts}[1]=~/b/i){
$stat.="\nBad decoded:\n";
foreach $area (sort {$a cmp $b} keys %{$dec{bad}}){
$stat.=">".uc($area)."\n";
foreach $file (sort {lc($a) cmp lc($b)} keys %{$dec{bad}{$area}}){
$stat.=f2s(a2k($file)).s2s($dec{bad}{$area}{$file}[0])."bytes, expect $dec{bad}{$area}{$file}[1] bytes\n";
}
}
}


# incomplete
if(exists $dec{inc} and $file{sts}[1]=~/c/i){
$stat.="\nIncomplete:\n";
foreach $area (sort {$a cmp $b} keys %{$dec{inc}}){
$stat.=">".uc($area)."\n";
foreach $file (sort {lc($a) cmp lc($b)} keys %{$dec{inc}{$area}}){
$stat.=f2s(a2k($file)).s2s($dec{inc}{$area}{$file}[1])."section(s) of $dec{inc}{$area}{$file}[0]\n";
}
}
}


if($stat){
open(STS,"> $file{sts}[0]") || uplog("$file{sts}[0]: $!");
print STS "$stat\n\n$ver\n";
close(STS);
}

}





# save dupebase
if(exists $file{dup}){
 uplog("Saving dupe base");
 dbmopen(%dup,$file{dup},0660) || errlog("$file{dup}: $!");
 %dup=%dupe;
 dbmclose(%dup);
}





# save resorce file
if(exists $file{res}){
unlink $file{res};
uplog("Saving resource file");
dbmopen(%res, $file{res}, 0660) || errlog("$file{res}: $!");
 ($i,%res)=(0);
 foreach $area (sort {$a cmp $b} keys %uue){
 foreach $file (sort {lc($a) cmp lc($b)} keys %{$uue{$area}}){

  # delete old uue sections
  if(time()-$uuehead{$area}{$file}{time} > $set{keep}*86400){
  uplog("Remove old section for $file (".int((time()-$uuehead{$area}{$file}{time})/86400)." days)");
  next;
  }

   foreach(keys %{$uue{$area}{$file}}){
   $res{$i++}="$area\0$file\0$_\0$uuehead{$area}{$file}{time}\0$uuehead{$area}{$file}{last}\0$uuehead{$area}{$file}{size}\0$uue{$area}{$file}{$_}";
   }
 }
 }
dbmclose(%res);
}






# unlink pkts
if($set{del} and %pktbase){
 uplog("Remove pkt");
  foreach(keys %pktbase){ unlink $pktbase{$_}[0] || uplog("$pktbase{$_}[0]: $!") }
}



uplog("Exit 0\n");


exit 0;







sub uplog{
return unless exists $file{log};
my $str=shift;
@_=localtime();
open(LOG, ">> $file{log}") || die $!;
print LOG sprintf("%02d/%02d/%02d %02d:%02d:%02d uuedec [$$] $str\n",$_[3],$_[4]+1,substr($_[5],-2),$_[2],$_[1],$_[0]);
close LOG;
}




sub errlog{
uplog($_[0]);
uplog("Exit 1\n");
exit 1;
}






sub esc{
my $str=shift;
$str=~s/(\W)/\\$1/g;
$str=~s/\\\*/\.*/g;
$str=~s/\\\?/\./g;
$str;
}






sub pkthead{
 undef %pkt;
 read PKT, $_, 58;
 return 0 unless length $_ == 58;
 @pkt{'fromnode','tonode','year','month','day','hour','min','sec','rate','ver','fromnet','tonet','prodx','password',
      'fromzone','tozone','filler','capvalid','prodcode','capword','fromzone','tozone','frompnt','topnt','proddata'}=unpack "vvvvvvvvvvvvvA8vvvvvvvvvvV",$_;
}




sub msgs{
 while(msghead()){ msgrb() }
}




sub msghead{
 undef %msg;
 read PKT, $_, 14;
 @msg{'type','fromnode','tonode','fromnet','tonet','flags','dummy'} = unpack "vvvvvvv", $_;
 return 0 unless $msg{type};
 @msg{'date','to','from','subj','area'}=(msgrh(),msgrh(),msgrh(),msgrh(),msgra());
}





sub msgrh{
 my $str='';
 while(read PKT, $_, 1){ (ord($_) == 0) ? last : ($str.=$_) }
 $str;
}





sub msgra{
 my $str='';
 my $pos=tell PKT;
 read PKT, $_, 12;
 seek PKT, $pos, 0;
 return "netmail" if /^area:netmail$/i or !/^area:/i;
 while(read PKT, $_, 1){ (ord($_) == 13) ? last : ($str.=$_) }
 lc(substr $str, 5);
}







sub msgrb{
my @body=split /[\r\n]+/, msgrh();

return unless defined areapath($msg{area});

my $i;

for($i=0;$i<@body;$i++){

 # uue 'section num of num of file file.name'
 $i=getuue($i,$1,$2,$3,@body), next if $body[$i]=~/section\s+(\d+)\s+of\s+(\d+)\s+of.*\s+file\s+(\S+)/i;

 # uue 'section num of file file.name'
 $i=getuue($i,$1, 0,$2,@body), next if $body[$i]=~/section\s+(\d+)\s+of.*\s+file\s+(\S+)/i;

 # uue 'begin num file.name'
 $i=getuue($i, 1, 1,$1,@body), next if $body[$i]=~/begin\s+\d+\s+(\S+)/i;

}

}





sub getuue{
my ($i,$cur,$last,$file,@uue)=@_;
my $uue=undef;

 # skip nonsens section
 return $i if $last and $cur > $last;

 # get 1st pos of uue
 for($i=$i;$i<@uue;$i++){
  last if $uue[$i]=~/^M/;
  return $i if $uue[$i]=~/^(sum|end)/i or length $uue[$i] <= 1 or not defined $uue[$i+1];
 } 

 # get uue code
 for($i=$i;$i<@uue;$i++){
  last if $uue[$i]=~/[\x00-\x1F\x61-\xFF]/ or length $uue[$i] <= 1;
  $uue.="$uue[$i]\n";
 }

 # if uue not found
 return $i unless $uue;

 # detect checksum at last section

 # if last section unknown
 $last=$cur if $last == 0 and (not exists $uuehead{$msg{area}}{$file}{last} or $uuehead{$msg{area}}{$file}{last} < $cur);
 $last=$uuehead{$msg{area}}{$file}{last} unless $last;

 if($cur == $last){
  for my $j($i..$i+5){
  last unless defined $uue[$j];
  $uuehead{$msg{area}}{$file}{size}=$1 if $uue[$j]=~/^sum\s+\S+\s+\d+\/(\d+)/i;
  }
 }

$uue{$msg{area}}{$file}{$cur}=$uue;


@{$uuehead{$msg{area}}{$file}}{'time','last','subj','from'}=(time(),$last,@msg{'subj','from'});
$uuehead{$msg{area}}{$file}{size}=-1 unless exists $uuehead{$msg{area}}{$file}{size};

uplog("Trying: $file (section $cur of $last, area $msg{area})");

return $i;
}








sub areapath{
my $echo=shift;

foreach $i (@echo){
$mask=esc($i->[0]);
 if($echo=~/^$mask$/i){
  return $echo if $i->[1] eq '*';
  return $i->[1];
 }
}

return undef;
}



sub a2k{
my $str=shift;
return $str unless exists $file{rec};
  eval "\$str=~tr/$in/$out/";
$str;
}




sub f2s{ " ".substr($_[0],0,15)." "."."x(15-length $_[0]) }




sub s2s{ "."x(8-length $_[0])." $_[0] " }
















sub savefile{
my ($area,$file,$dec,$size,$subj,$nfrom)=@_;
my $forig=$file;





# predefined cmd (may be file extension change to .000, etc)
my $cmd=undef;
foreach(sort {$a<=>$b} keys %archext){
 my $ext=esc($archext{$_}[0]);
 $cmd=$archext{$_}[1], last if $file=~/^$ext$/i;
}



# detect dupes and update dupebase
if(exists $file{dup}){
  if(exists $dupe{lc($file)} and $dupe{lc($file)} == $size){
  uplog("Skip dupe $file $size bytes, area $area)");
  return;
  }
 $dupe{lc($file)}=$size;
}




# bad file name
$file=~s/[\x00-\x20\xB0-\xDF\xF2-\xFF\"\*\/\:\<\>\?\\\|]/_/g if $set{cmp};






# file name translate
if($set{code} == 2){
 $file=~tr//ABVGDEJZIIKLMNOPRSTUFHC'A'Aabvgdejziiklmnoprstufhc'a'a/;
 $file=~s//YO/;
 $file=~s//CH/;
 $file=~s//SH/;
 $file=~s//SCH/;
 $file=~s//IU/;
 $file=~s//YA/;
 $file=~s//yo/;
 $file=~s//ch/;
 $file=~s//sh/;
 $file=~s//sch/;
 $file=~s//iu/;
 $file=~s//ya/;
}

$file=a2k($file) if $set{code} == 1;






# convert filename dos compat (+ upper case)
if($set{dos}){
 @_=split /\./, uc($file);
 $file=substr $_[0],0,8;
 $file.=".".substr $_[-1],0,3 if @_ > 1;
}





# check file on disk
my $path="$spooldec/".(areapath($area) || return);

if(-f "$path/$file"){
    if($set{dupe} == 1){ uplog("Overwrite $file (file exists on disk)") }
 elsif($set{dupe} == 2){ uplog("Rename $file (file exists on disk)");
                         $file=$1 if $file=~/^(.+)\./;
                         my $count='000';
                         while(){
                          $file.=".$count", last if $count eq '999' or not -f "$path/$file.$count";
                          $count++;
                         }
                       }
                   else{ uplog("Skip $file (file exists on disk)"); return }
}





# save file
unless(-d $path){ mkdir($path, 0760) || errlog("$path: $!") }
uplog("Write: $path/$file");
 open(DEC, "> $path/$file") || errlog("$path/$file: $!");
 binmode DEC;
 syswrite(DEC, $dec, $size);
 close(DEC);




# make file.bbs/desc
return unless exists $file{bbs};

my $form=$set{form};

my $desc=(getdesc($path,$file,$cmd) || $subj) if $form=~/%d/;

$form=~s/%o/$forig/g;
$form=~s/%n/$nfrom/g;
$form=~s/%y/$area/g;
$form=~s/%s/$subj/g;
$form=~s/%r/$size/g;
$form=~s/%l/\n/g;
$form=~s/%d/$desc/g;
$form=a2k($form) if $set{rec};
$form=~s/%f/$file/g;

my $bbs;
my @bbs=split /[\r\n]/,$form;
 $bbs=shift @bbs;
  if($bbs=~/%(\d+)/){
  @_=split /%$1/,$bbs,2;
  $bbs=substr($_[0],0,$1)." "x($1-length $_[0])."$_[1]\n";
  }

foreach(@bbs){ $bbs.=" "x$set{next}."$_\n" }


my ($fbp,$fbf)=@{$file{bbs}};

$fbf=~s/%f/$file/g;

unless(-d "$path/$fbp"){ mkdir("$path/$fbp", 0760) || errlog("$path/$fbp: $!") }


$fbf="$path/$fbp/$fbf";
$fbf=~s/\/\.\//\//g;
$fbf=~s/\/+/\//g;


# update filebbs
uplog("Update $fbf");

open(BBS, ">> $fbf") || errlog("$fbf: $!");
print BBS $bbs;
close BBS;
}






sub getdesc{
my ($path,$file,$cmd)=@_;
my ($id,$diz);

open(ARCH,"< $path/$file") || (uplog("$path/$file: $!"), return $!);
binmode ARCH;
 foreach $id (sort {$a<=>$b} keys %archid){
  seek ARCH,abs($archid{$id}[2]),($archid{$id}[2] < 0 ? 2 : 0);
  read ARCH, $_, length $archid{$id}[1];
  $cmd=$archid{$id}[0],last if $_ eq $archid{$id}[1];
 }
close(ARCH);

$cmd=$archdef unless defined $cmd;

system getcmd($cmd,$file,$path);
system getcmd($archdef,$file,$path) unless -f "$file{tmp}/$file{diz}";

open(DIZ,"< $file{tmp}/$file{diz}") || return undef;
 while(<DIZ>){
 s/[\r\n]//;
 $diz.="$_\n"}
 $diz=~s/[\r\n]$//;
close(DIZ);

unlink("$file{tmp}/$file{diz}") || errlog("$file{tmp}/$file{diz}: $!");

$diz;
}


sub getcmd{
my ($cmd,$file,$path)=@_;

# os hack
if($^O=~/(win32|os2)/i){
 $cmd=~s/%a/$file/g;
 $cmd=~s/%p/$path/g;
 $cmd=~s/%t/$file{tmp}/g;
 $cmd=~s/%d/$file{diz}/g;
 $cmd=~s/\//\\/g;
}else{
 $cmd=~s/%a/\Q$file/g;
 $cmd=~s/%p/\Q$path/g;
 $cmd=~s/%t/\Q$file{tmp}/g;
 $cmd=~s/%d/\Q$file{diz}/g;
}

$cmd;
}
